package connection;

import common.CommonVariables;
import communication.ReadWrite;
import gui.BlueMIDlet;
import java.io.IOException;
import javax.microedition.lcdui.Alert;
import javax.microedition.lcdui.AlertType;
import javax.microedition.lcdui.Canvas;

/**
 *
 * @author sumanta
 */
public class ReadingThread extends Thread {

    BlueMIDlet parent;

    public ReadingThread(BlueMIDlet parent) {
        this.parent = parent;
    }

    public void run() {
        while (true) {
            try {
                if (CommonVariables.in == null) {
                    CommonVariables.in = CommonVariables.conn.openInputStream();
                }
                if (CommonVariables.out == null) {
                    CommonVariables.out = CommonVariables.conn.openOutputStream();
                }
                String input = ReadWrite.read();
                //parent.getFrmChatting().append(input);

                try {
                    boolean valid = CommonVariables.engine.setMove(Integer.parseInt(input), false);
                    if (!valid) {
                        parent.switchDisplayable(new Alert("Error", "Invalid Move!", null, AlertType.ERROR),
                                parent.getGameCanvas());

                    } else {
                        CommonVariables.myTurn = true;
                        parent.getTurnString().setText("Your turn");
                        ((Canvas)(parent.getGameCanvas())).repaint();
                    }
                } catch (NumberFormatException nfe) {
                    if (input.equals("win")) {
                        parent.switchDisplayable(new Alert("Your opponent won!!"), parent.getTxtConnection());
                    }
                }
            
            } catch (IOException ex) {
                System.out.println("Exception in read thread");
                ex.printStackTrace();
            }
        }

    }
}
