package connection;

import common.CommonVariables;
import communication.ReadWrite;
import gui.BlueMIDlet;
import java.io.IOException;
import javax.bluetooth.BluetoothStateException;
import javax.bluetooth.DiscoveryAgent;
import javax.bluetooth.LocalDevice;
import javax.microedition.io.Connector;
import javax.microedition.io.StreamConnection;
import javax.microedition.io.StreamConnectionNotifier;
import javax.microedition.lcdui.Alert;
import javax.microedition.midlet.MIDlet;

/**
 *
 * @author sumanta
 */
public class BlueServer implements Runnable {

    private StreamConnection conn;
    private StreamConnectionNotifier notifier;
    private LocalDevice device;
    private static String serverUrl = "btspp://localhost:" + CommonVariables.MYUUID +
            ";name=rfcommtest;authorize=true";
    private BlueMIDlet parent;

    public BlueServer(MIDlet parent) {
        this.parent = (BlueMIDlet) parent;
        try {
            /*
             * get the instance of local device
             */
            device = LocalDevice.getLocalDevice();
            device.setDiscoverable(DiscoveryAgent.GIAC);

            //starting the connection notifier
            notifier = (StreamConnectionNotifier) Connector.open(serverUrl);
            System.out.println("server about to start..");
        } catch (BluetoothStateException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }

    }

    public void run() {
        /*
         * In this class the service will be listening for incoming connections
         */
        System.out.println("server is up");
        try {
            conn = notifier.acceptAndOpen();
            CommonVariables.conn = conn;
            System.out.println("connection found: " + conn);
            parent.getTxtConnection().setString(conn.toString());
            parent.switchDisplayable(null, parent.getTxtConnection());
            //((BlueP2P)parent).removeTicker();
//            new Thread() {
//
//                public void run() {
//                    while (true) {
//                        if (CommonVariables.in == null) {
//                            try {
//                                CommonVariables.in = CommonVariables.conn.openInputStream();
//                            } catch (IOException ex) {
//                                ex.printStackTrace();
//                            }
//                            }
//                        if (CommonVariables.out == null) {
//                            try {
//                                CommonVariables.out = CommonVariables.conn.openOutputStream();
//                            } catch (IOException ex) {
//                                ex.printStackTrace();
//                            }
//                            }
//                        String input = ReadWrite.read();
//                        parent.getFrmChatting().append(input);
//                        
//                        //just checkin
//                        try{
//                            CommonVariables.engine.setMove(Integer.parseInt(input));
//                        }catch(NumberFormatException nfe)
//                        {
//                            if(input.equals("win"))
//                                parent.switchDisplayable(new Alert("Your opponent won!!"), parent.getTxtConnection());
//                        }
//                        
//                        
//                        CommonVariables.myTurn = true;
//                        parent.getTurnString().setText("Your turn");
//                    }
//
//                }
//            }.start();
            new ReadingThread(parent).start();
            //I have received connection, so I am the master ;)
            CommonVariables.myTurn = true;
            CommonVariables.myName = "server";
            CommonVariables.myChar = 'X';
            parent.getTurnString().setText("Your turn");
        } catch (IOException e) {
            System.out.println("problem in server connection");
            e.printStackTrace();
        }

    }
}
